﻿using System;
using System.Collections.Generic;
using System.Web.Http;
using WebApiScopedLifetimeDependencyResolverSample.Models;

namespace WebApiScopedLifetimeDependencyResolverSample.Controllers
{
    public class ValuesController : ApiController
    {
        private readonly IValuesRepository repository;

        public ValuesController(IValuesRepository repository)
        {
            if (repository == null)
            {
                throw new ArgumentNullException("repository");
            }

            this.repository = repository;
        }

        // GET api/values
        public IEnumerable<int> Get()
        {
            return this.repository.GetAllValues();
        }

        // GET api/values/5
        public int Get(int id)
        {
            return this.repository.GetValue(id);
        }

        // POST api/values
        public void Post(string value)
        {
        }

        // PUT api/values/5
        public void Put(int id, string value)
        {
        }

        // DELETE api/values/5
        public void Delete(int id)
        {
        }

        protected override void Dispose(bool disposing)
        {
            // Signal a breakpoint here for debugging purposes.
            //System.Diagnostics.Debugger.Break();

            base.Dispose(disposing);
        }
    }
}